#include "ImageLib.h"

#ifdef NEW_HEADER_NAMES
#include <iostream>
using std::cout;
using std::cerr;
using std::endl;
using std::ios;
#else
#include <iostream.h>
#endif

#include "ucharImage.h"
#include "PGMFile.h"

//Calculate distortion between two PGM files
int main(int argc, char *argv[])
{
  if (argc < 3) {
    cerr << "Usage: " << argv[0] << " file1 file2\n";
    return 1;
  }
  //Define images with unsigned char pixels
  ucharImage a, b;
  //Load images in PGM format
  if (!a.load(PGMFile(argv[1]))) {
    cerr << "Error loading image " << argv[1] << endl;
    return 2;
  }
  if (!b.load(PGMFile(argv[2]))) {
    cerr << "Error loading image " << argv[2] << endl;
    return 2;
  }
 
  cout.setf(ios::fixed);
  cout.setf(ios::showpoint);
  //Print Mean Square Error, Root Mean Square Error, and 
  //Peak Signal to Noise Ration
  cout << "MSE:  " << MSE(a, b) << endl
       << "RMSE: " << RMSE(a, b) << endl
       << "PSNR: " << PSNR(a, b) << endl;
  
  return 0;
}

