#include "ImageLib.h"

#ifdef NEW_HEADER_NAMES
#include <iostream>
#include <iomanip>
using std::cout;
using std::endl;
using std::ios;
using std::setw;
#else
#include <iostream.h>
#include <iomanip.h>
#endif

#include "floatImage.h"
#include "ImageIterate.h"

// Illustrate use of image iterator classes
int main(int argc, char *argv[])
{
  unsigned int w = 8;
  unsigned int h = 8;

  if (argc > 1)
    w = atoi(argv[1]);
  if (argc > 2)
    h = atoi(argv[2]);
  
  //Define image of width w and height h with float pixels initialised to 0.0
  floatImage fi(w, h, 0.0);

  //Define iterator, following an alternating raster scan, for an
  //image with the same size as image fi
  AlternatingRasterIterate imit(fi.size());

  //Raster scan iterator
  //RasterIterate imit(fi.size());
  //Zig-zag scan iterator
  //ZigzagIterate imit(fi.size());

  unsigned int c = 0;

  //While iterator path is not complete, set pixel at current iterator 
  //position to the value of c, move the iterator on to the next
  //position, and increment c
  while (imit.state() != ImageIterate::stop)
      fi(imit++) = c++;

  cout << endl << endl << setw(3) << fi << endl;
  
  return 0;
}

