#include "ImageLib.h"

#ifdef NEW_HEADER_NAMES
#include <iostream>
#include <iomanip>
using std::cout;
using std::endl;
using std::ios;
using std::setw;
#else
#include <iostream.h>
#include <iomanip.h>
#endif

#include "ucharImage.h"
#include "ImageIterate.h"

// Illustrate extraction and insertion of subimages
int main()
{
  //Define 8 x 8image with unsigned char pixels initialised to 0
  ucharImage uci(8, 8, 0);

  //Define zig-zag scan iterator, for an image with the same size as image uci
  ZigzagIterate imit(uci.size());

  //Initialise pixel values
  unsigned int c = 0;
  while (imit.state() != ImageIterate::stop)
      uci(imit++) = c++;

  //Display image
  cout << endl << endl << setw(4) << uci << endl;
  
  //Create temporary image containing the 4 x 4 subimage at position (0,0) of uci 
  ucharImage tmp = uci(0,0,4,4);
  //Assign the 4 x 4 subimage at (4,4) to the subimage at (0,0)
  uci(0,0,4,4) = uci(4,4,4,4);
  //Assign the temporary image to the 4 x 4 subimage at (4,4)
  uci(4,4,4,4) = tmp;

  //Display image
  cout << endl << setw(4) << uci << endl;

  return 0;
}

