// -*- Mode:c++ -*-
/********************************COPYRIGHT*************************************
  
    This file forms a part of ImageLib, a C++ class library for image 
    processing.

    Copyright (C) 1998-2003 Brendt Wohlberg  <brendt@dip.ee.uct.ac.za>

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

********************************COPYRIGHT*************************************/

/*
  
  $Id: ImageFile.h,v 1.1 2003/02/01 17:46:23 brendt Exp $

 */
 
#ifndef _ImageFile_h
#define _ImageFile_h

#include "ImageLib.h"
#include "ImageSize.h"
#include "ProtoVectorFile.h"

//! unit="Image and Vector Types"
//! module="File Access"
//! level = 2

//: Abstract base class for image file hierarchy 
class ImageFile : public virtual ProtoVectorFile {
public:
  //Construct given filename
  ImageFile(char *name) : ProtoVectorFile(name) {}
  //Return image size 
  virtual ImageSize isize() const = 0;
};

#endif
