// -*- Mode:c++ -*-
/********************************COPYRIGHT*************************************
  
    This file forms a part of ImageLib, a C++ class library for image 
    processing.

    Copyright (C) 1998-2003 Brendt Wohlberg  <brendt@dip.ee.uct.ac.za>

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

********************************COPYRIGHT*************************************/

/*

  $Id: ProtoVectorFile.cc,v 1.1 2003/02/01 17:46:23 brendt Exp $

*/

#include "ProtoVectorFile.h"

#include <string.h>
#if defined(HAVE_UNISTD_H)
#include <unistd.h>
#else
#error unistd.h required for declaration of access function
#endif

ProtoVectorFile::ProtoVectorFile(char *name)
{
  if (name)
    {
      fname = new char [strlen(name)+1];
      strcpy(fname, name);
    }
  else
    fname = 0;
}


ProtoVectorFile::~ProtoVectorFile()
{
  delete [] fname;
}


void ProtoVectorFile::set_filename(char *name)
{
  delete [] fname;
  if (name)
    {
      fname = new char [strlen(name)+1];
      strcpy(fname, name);
    }
  else
    fname = 0;
}

bool ProtoVectorFile::readable() const
{
  return bool(!access(fname, R_OK | F_OK));
}


bool ProtoVectorFile::writable() const
{
  return bool(!access(fname, W_OK | F_OK));
}

