// -*- Mode:c++ -*-
/********************************COPYRIGHT*************************************
  
    This file forms a part of ImageLib, a C++ class library for image 
    processing.

    Copyright (C) 1998-2003 Brendt Wohlberg  <brendt@dip.ee.uct.ac.za>

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

********************************COPYRIGHT*************************************/

/*
  
  $Id: ProtoVectorFile.h,v 1.1 2003/02/01 17:46:23 brendt Exp $

 */

 
#ifndef _ProtoVectorFile_h
#define _ProtoVectorFile_h

#include "ImageLib.h"

//! unit="Image and Vector Types"
//! module="File Access"
//! level = 1

//: Abstract base class for image file hierarchy
class ProtoVectorFile {
private:
  char *fname;

public:
  //Constructor taking filename as argument
  ProtoVectorFile(char *name);
  virtual ~ProtoVectorFile();
  
  //Return filename
  const char* filename(void) const { return fname; }
  //Change filename
  void set_filename(char *name);

  //Check whether disk file is readable
  bool readable() const;
  //Check whether disk file is writable
  bool writable() const;

  //Check whether header format is OK
  virtual bool format_OK() const = 0;
};

#endif
