// -*- Mode:c++ -*-
/********************************COPYRIGHT*************************************
  
    This file forms a part of ImageLib, a C++ class library for image 
    processing.

    Copyright (C) 1998-2003 Brendt Wohlberg  <brendt@dip.ee.uct.ac.za>

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

********************************COPYRIGHT*************************************/

/*

  $Id: Subimage.cc,v 1.1 2003/02/01 17:46:23 brendt Exp $
 
*/

#ifndef _Subimage_cc
#define _Subimage_cc

#if !defined(INCLUDE_TEMPLATE_DEFINITIONS)
#include "Subimage.h"
#endif

template <class T, class R>
Subimage<T, R>::Subimage(const Image<T, R>& im,
			 unsigned int ix, unsigned int iy,
			 unsigned int w, unsigned int h) : image(im)
{
  x = ix;
  y = iy;
  width = w;
  height = h;
}

template <class T, class R>
const Subimage<T, R>& Subimage<T, R>::operator=(const Subimage<T, R>& subimage)
{
  unsigned int i,j;
  for (j = 0; j < height; j++)
	for (i = 0; i < width; i++)
	  image(x + i, y + j) =
	    subimage.image(subimage.x + i, subimage.y + j);
  return subimage;
}


template <class T, class R>
const Image<T, R>& Subimage<T, R>::operator=(const Image<T, R>& im)
{
  unsigned int i,j;
  for (j = 0; j < height; j++)
	for (i = 0; i < width; i++)
	  image(x + i, y + j) = im(i, j);
  return im;
}

#endif
