// -*- Mode:c++ -*-
/********************************COPYRIGHT*************************************
  
    This file forms a part of ImageLib, a C++ class library for image 
    processing.

    Copyright (C) 1998-2003 Brendt Wohlberg  <brendt@dip.ee.uct.ac.za>

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

********************************COPYRIGHT*************************************/

/*

  $Id: Subimage.h,v 1.1 2003/02/01 17:46:23 brendt Exp $

  
*/


#ifndef _Subimage_h
#define _Subimage_h

/* NB: Should have conversion from ProtoVectorRef as well */

//! unit="Image and Vector Types"
//! module="Image Support Classes"
//! level = 1

template <class T, class R>
class Image;

template <class T, class R>
class Vector;

//: Template class of subimages
// Subimage<T, R> supports subimage operations on Image<T, R>
template <class T, class R>
class Subimage {
private:
  unsigned int x;
  unsigned int y;
  unsigned int width;  
  unsigned int height;
  const Image<T, R>& image;

public:
  //Construct subvector from vector with position information;  
  //x, y - coords of left upper corner of subimage
  //w, h - width and height of subimage
  Subimage(const Image<T, R>& im, 
	   unsigned int x = 0, unsigned int y = 0,
	   unsigned int w = 0, unsigned int h = 0);
  //Assignment operator from subimage
  const Subimage<T, R>& operator=(const Subimage<T, R>& subimage);
  //Assignment operator from image
  const Image<T, R>& operator=(const Image<T, R>& im);

  friend class Image<T, R>;
  friend class Vector<T, R>;
};

#if defined(INCLUDE_TEMPLATE_DEFINITIONS)
#include "Subimage.cc"
#endif

#endif
