// -*- Mode:c++ -*-
/********************************COPYRIGHT*************************************
  
    This file forms a part of ImageLib, a C++ class library for image 
    processing.

    Copyright (C) 1998-2003 Brendt Wohlberg  <brendt@dip.ee.uct.ac.za>

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

********************************COPYRIGHT*************************************/

/*

  $Id: Subvector.cc,v 1.1 2003/02/01 17:46:23 brendt Exp $
  
*/

#ifndef _Subvector_cc
#define _Subvector_cc

#if !defined(INCLUDE_TEMPLATE_DEFINITIONS)
#include "Subvector.h"
#endif

template <class T, class R>
Subvector<T, R>::Subvector(const Vector<T, R>& v, unsigned int ix,
		        unsigned int w) : vector(v)
{
  x = ix;
  width = w;
}


template <class T, class R>
const Subvector<T, R>& Subvector<T, R>::operator=(const Subvector<T, R>&
						  subvector)
{
  unsigned int i;
  for (i = 0; i < width; i++)
	  vector(x + i) = subvector.vector(subvector.x + i);
  return subvector;
}


template <class T, class R>
const Vector<T, R>& Subvector<T, R>::operator=(const Vector<T, R>& vec)
{
  unsigned int i;
  for (i = 0; i < width; i++)
	for (i = 0; i < width; i++)
	  vector(x + i) = vec(i);
  return vec;
}

#endif
