// -*- Mode:c++ -*-
/********************************COPYRIGHT*************************************
  
    This file forms a part of ImageLib, a C++ class library for image 
    processing.

    Copyright (C) 1998-2003 Brendt Wohlberg  <brendt@dip.ee.uct.ac.za>

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

********************************COPYRIGHT*************************************/

/*

  $Id: Subvector.h,v 1.1 2003/02/01 17:46:23 brendt Exp $
  
*/


#ifndef _Subvector_h
#define _Subvector_h

//! unit="Image and Vector Types"
//! module="Vector Support Classes"
//! level = 1

template <class T, class R>
class Vector;

//: Template class of subvectors
// Subvector<T, R> supports subvector operations on Vector<T, R>
template <class T, class R>
class Subvector {
private:
  unsigned int x;
  unsigned int width;  
  const Vector<T, R>& vector;

public:
  //Construct subvector from vector with position information;  
  //x - start of subvector,  w  - width of subvector
  Subvector(const Vector<T, R>& im, unsigned int x = 0, unsigned int w = 0);
  //Assignment operator from subvector
  const Subvector<T, R>& operator=(const Subvector<T, R>& subvector);
  //Assignment operator from vector
  const Vector<T, R>& operator=(const Vector<T, R>& im);

  friend class Vector<T, R>;
};

#if defined(INCLUDE_TEMPLATE_DEFINITIONS)
#include "Subvector.cc"
#endif

#endif
