// -*- Mode:c++ -*-
/********************************COPYRIGHT*************************************
  
    This file forms a part of ImageLib, a C++ class library for image 
    processing.

    Copyright (C) 1998-2003 Brendt Wohlberg  <brendt@dip.ee.uct.ac.za>

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

********************************COPYRIGHT*************************************/

/*

  $Id: Arguments.h,v 1.1 2003/02/01 17:46:23 brendt Exp $

*/


#ifndef _Arguments_h
#define _Arguments_h

#include "ImageLib.h"

#ifdef NEW_HEADER_NAMES
#include <iostream>
using std::ostream;
#else
#include <iostream.h>
#endif

//! unit="Miscellaneous"
//! module="Command Line Arguments" 
//! level = 1

//: Configuration information for command line parsing class
struct CLArg {
  char *label;
  char *description;
};

//: Command line argument parsing mechanism
class Arguments {
private:
  char **labels;
  char **values;

  void error(char *prog, const CLArg* params, const CLArg* optparams,
	     const CLArg* flags);
public:
  Arguments(int argc, char* argv[], const CLArg* params,
	    const CLArg* optparams, const CLArg* flags);
  ~Arguments();
  char *arg(char *label);
  bool value(char *label);
  bool value(char *label, char &fv);
  bool value(char *label, unsigned int& fv);
  bool value(char *label, int& fv);
  bool value(char *label, float& fv);
  bool value(char *label, double& fv);

  friend ostream& operator<<(ostream &s, const Arguments& a);
};

#endif



    
