// -*- Mode:c++ -*-
/********************************COPYRIGHT*************************************
  
    This file forms a part of ImageLib, a C++ class library for image 
    processing.

    Copyright (C) 1998-2003 Brendt Wohlberg  <brendt@dip.ee.uct.ac.za>

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

********************************COPYRIGHT*************************************/

/*
  
  $Id: SymWavelet.h,v 1.1 2003/02/01 17:46:23 brendt Exp $

 */

#ifndef _SymWavelet_h
#define _SymWavelet_h

#include "Wavelet.h"

//! unit="Wavelets"
//! module="Support" 
//! level = 2

//:Wavelet class using symmetric extension
class SymmetricWavelet : public Wavelet {
public:
  SymmetricWavelet(const Sequence& h, const Sequence& ht,
		   Sign sign = Negative, double error = prerror);
  SymmetricWavelet(double *hs, unsigned int hl,
		   double *hts, unsigned int htl);

  floatVectorRef analysislow(const floatVector &fv) const;
  floatVectorRef analysishigh(const floatVector &fv) const;
  floatVectorRef synthesis(const floatVector &lowchannel,
		      	   const floatVector &highchannel) const;

  floatVectorRef analyse(const floatVector &fv) const;
  floatVectorRef synthesise(const floatVector &fv) const;
  
  floatVectorRef fwt(const floatVector &fv, unsigned int lev = 0) const;
  floatVectorRef ifwt(const floatVector &fv, unsigned int lev = 0) const;

  floatImageRef fwt_nstd(const floatImage &fi, unsigned int lev = 0) const;
  floatImageRef ifwt_nstd(const floatImage &fi, unsigned int lev = 0) const;
};


#endif
