// -*- Mode:c++ -*-
/********************************COPYRIGHT*************************************
  
    This file forms a part of ImageLib, a C++ class library for image 
    processing.

    Copyright (C) 1998-2003 Brendt Wohlberg  <brendt@dip.ee.uct.ac.za>

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

********************************COPYRIGHT*************************************/

/*
  
  $Id: WvltFilters.h,v 1.1 2003/02/01 17:46:23 brendt Exp $

 */

#ifndef _WvltFilters_h
#define _WvltFilters_h

#include "ImageLib.h"
#include "floatVector.h"
#include "Sequence.h"
#include "Wavelet.h"
#include "SymWavelet.h"

//! unit="Wavelets"
//! module="Support" 
//! level = 2

extern Wavelet Haar;

extern Wavelet Daubechies4;
extern Wavelet Daubechies6;
extern Wavelet Daubechies8;
extern Wavelet Daubechies10;
extern Wavelet Daubechies12;
extern Wavelet Daubechies20;

extern Wavelet Coiflet2;
extern Wavelet Coiflet4;
extern Wavelet Coiflet6;

extern Wavelet Adelson;
extern Wavelet Battle;

extern SymmetricWavelet Antonini9_7;

extern SymmetricWavelet Villasenor2_6;
extern SymmetricWavelet Villasenor5_3;
extern SymmetricWavelet Villasenor6_10;
extern SymmetricWavelet Villasenor9_3;
extern SymmetricWavelet Villasenor9_7;
extern SymmetricWavelet Villasenor13_11;
extern SymmetricWavelet Villasenor18_10;

extern SymmetricWavelet Brislawn9_7;
extern SymmetricWavelet Brislawn10_10;

extern SymmetricWavelet Silva6_6;

extern SymmetricWavelet Odegard9_7;

extern SymmetricWavelet PseudoCoiflet13_7;
extern SymmetricWavelet Burt5_7;

extern SymmetricWavelet Spline3_9;
extern SymmetricWavelet Spline4_12;
extern SymmetricWavelet Spline5_3;
extern SymmetricWavelet Spline8_4;
extern SymmetricWavelet Spline16_4;

//: Structure linking a wavelet with a string representing its name
struct WaveletDescription {
  Wavelet *wavelet;
  bool symmetric;
  char *description;
};

extern WaveletDescription predefined_wavelets[];
#endif

